/* See LICENSE file for copyright and license details. */

/* appearance */
static const unsigned int borderpx       = 2;   /* border pixel of windows */
static const unsigned int snap           = 16;  /* snap pixel */
static const int swallowfloating         = 0;   /* 1 means swallow floating windows by default */
static const unsigned int gappih         = 10;  /* horiz inner gap between windows */
static const unsigned int gappiv         = 10;  /* vert inner gap between windows */
static const unsigned int gappoh         = 10;  /* horiz outer gap between windows and screen edge */
static const unsigned int gappov         = 10;  /* vert outer gap between windows and screen edge */
static const int smartgaps_fact          = 0;   /* 1 means no outer gap when there is only one window */
static const char autostartblocksh[]     = "autostart_blocking.sh";
static const char autostartsh[]          = "autostart.sh";
static const char dwmdir[]               = "dwm";
static const char localshare[]           = ".local/share";
static const int showbar                 = 1;   /* 0 means no bar */
static const int topbar                  = 1;   /* 0 means bottom bar */
/* Status is to be shown on: -1 (all monitors), 0 (a specific monitor by index), 'A' (active monitor) */
static const int statusmon               = 'A';
static const unsigned int systrayspacing = 2;   /* systray spacing */
static const int showsystray             = 1;   /* 0 means no systray */
/* Indicators: see patch/bar_indicators.h for options */
static int tagindicatortype              = INDICATOR_TOP_LEFT_SQUARE;
static int tiledindicatortype            = INDICATOR_NONE;
static int floatindicatortype            = INDICATOR_TOP_LEFT_SQUARE;
static int fakefsindicatortype           = INDICATOR_PLUS;
static int floatfakefsindicatortype      = INDICATOR_PLUS_AND_LARGER_SQUARE;
static void (*bartabmonfns[])(Monitor *) = { monocle /* , customlayoutfn */ };
static const char *fonts[]               = { 
  "FontAwesome:size=12",
  "mononoki:size=12",
};
static const char dmenufont[]            = "mononoki:size=12";

static char normfgcolor[]                = "#bbbbbb";
static char normbgcolor[]                = "#222222";
static char normbordercolor[]            = "#444444";
static char normfloatcolor[]             = "#db8fd9";

static char selfgcolor[]                 = "#111111";
static char selbgcolor[]                 = "#ffd700";
static char selbordercolor[]             = "#ffd700";
static char selfloatcolor[]              = "#ffd700";

static char titlenormfgcolor[]           = "#bbbbbb";
static char titlenormbgcolor[]           = "#222222";
static char titlenormbordercolor[]       = "#444444";
static char titlenormfloatcolor[]        = "#db8fd9";

static char titleselfgcolor[]            = "#111111";
static char titleselbgcolor[]            = "#ffd700";
static char titleselbordercolor[]        = "#ffd700";
static char titleselfloatcolor[]         = "#ffd700";

static char tagsnormfgcolor[]            = "#bbbbbb";
static char tagsnormbgcolor[]            = "#222222";
static char tagsnormbordercolor[]        = "#444444";
static char tagsnormfloatcolor[]         = "#db8fd9";

static char tagsselfgcolor[]             = "#111111";
static char tagsselbgcolor[]             = "#ffd700";
static char tagsselbordercolor[]         = "#ffd700";
static char tagsselfloatcolor[]          = "#ffd700";

static char hidnormfgcolor[]                 = "#ffd700";
static char hidnormbgcolor[]                 = "#222222";
static char hidselfgcolor[]              = "#ffd700";
static char hidselbgcolor[]             = "#ffd700";
static char hidbordercolor[]             = "#ffd700";
static char hidfloatcolor[]              = "#f76e0c";

static char urgfgcolor[]                 = "#bbbbbb";
static char urgbgcolor[]                 = "#222222";
static char urgbordercolor[]             = "#ff0000";
static char urgfloatcolor[]              = "#db8fd9";


static const unsigned int baralpha = 0xd0;
static const unsigned int borderalpha = OPAQUE;
static const unsigned int alphas[][3] = {
	/*                       fg      bg        border     */
	[SchemeNorm]         = { OPAQUE, baralpha, borderalpha },
	[SchemeSel]          = { OPAQUE, baralpha, borderalpha },
	[SchemeTitleNorm]    = { OPAQUE, baralpha, borderalpha },
	[SchemeTitleSel]     = { OPAQUE, baralpha, borderalpha },
	[SchemeTagsNorm]     = { OPAQUE, baralpha, borderalpha },
	[SchemeTagsSel]      = { OPAQUE, baralpha, borderalpha },
	[SchemeHidNorm]      = { OPAQUE, baralpha, borderalpha },
	[SchemeHidSel]       = { OPAQUE, baralpha, borderalpha },
	[SchemeUrg]          = { OPAQUE, baralpha, borderalpha },
};

static char *colors[][ColCount] = {
	/*                       fg                bg                border                float */
	[SchemeNorm]         = { normfgcolor,      normbgcolor,      normbordercolor,      normfloatcolor },
	[SchemeSel]          = { selfgcolor,       selbgcolor,       selbordercolor,       selfloatcolor },
	[SchemeTitleNorm]    = { titlenormfgcolor, titlenormbgcolor, titlenormbordercolor, titlenormfloatcolor },
	[SchemeTitleSel]     = { titleselfgcolor,  titleselbgcolor,  titleselbordercolor,  titleselfloatcolor },
	[SchemeTagsNorm]     = { tagsnormfgcolor,  tagsnormbgcolor,  tagsnormbordercolor,  tagsnormfloatcolor },
	[SchemeTagsSel]      = { tagsselfgcolor,   tagsselbgcolor,   tagsselbordercolor,   tagsselfloatcolor },
	[SchemeHidNorm]      = { hidnormfgcolor,   hidnormbgcolor,   hidbordercolor,       hidfloatcolor },
	[SchemeHidSel]       = { hidselfgcolor,    hidselbgcolor,    hidbordercolor,       hidfloatcolor },
	[SchemeUrg]          = { urgfgcolor,       urgbgcolor,       urgbordercolor,       urgfloatcolor },
};

/*
static char *statuscolors[][ColCount] = {
//	                       fg                bg                border                float 
	[SchemeNorm]         = { normfgcolor,      normbgcolor,      normbordercolor,      normfloatcolor },
	[SchemeSel]          = { selfgcolor,       selbgcolor,       selbordercolor,       selfloatcolor },
	[SchemeTitleNorm]    = { titlenormfgcolor, titlenormbgcolor, titlenormbordercolor, titlenormfloatcolor },
	[SchemeTitleSel]     = { titleselfgcolor,  titleselbgcolor,  titleselbordercolor,  titleselfloatcolor },
	[SchemeTagsNorm]     = { tagsnormfgcolor,  tagsnormbgcolor,  tagsnormbordercolor,  tagsnormfloatcolor },
	[SchemeTagsSel]      = { tagsselfgcolor,   tagsselbgcolor,   tagsselbordercolor,   tagsselfloatcolor },
	[SchemeHidNorm]      = { hidnormfgcolor,   hidnormbgcolor,   hidbordercolor,       hidfloatcolor },
	[SchemeHidSel]       = { hidselfgcolor,    hidselbgcolor,    hidbordercolor,       hidfloatcolor },
	[SchemeUrg]          = { urgfgcolor,       urgbgcolor,       urgbordercolor,       urgfloatcolor },
};
*/



/* Tags
 * In a traditional dwm the number of tags in use can be changed simply by changing the number
 * of strings in the tags array. This build does things a bit different which has some added
 * benefits. If you need to change the number of tags here then change the NUMTAGS macro in dwm.c.
 *
 * Examples:
 *
 *  1) static char *tagicons[][NUMTAGS*2] = {
 *         [DEFAULT_TAGS] = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I" },
 *     }
 *
 *  2) static char *tagicons[][1] = {
 *         [DEFAULT_TAGS] = { "•" },
 *     }
 *
 * The first example would result in the tags on the first monitor to be 1 through 9, while the
 * tags for the second monitor would be named A through I. A third monitor would start again at
 * 1 through 9 while the tags on a fourth monitor would also be named A through I. Note the tags
 * count of NUMTAGS*2 in the array initialiser which defines how many tag text / icon exists in
 * the array. This can be changed to *3 to add separate icons for a third monitor.
 *
 * For the second example each tag would be represented as a bullet point. Both cases work the
 * same from a technical standpoint - the icon index is derived from the tag index and the monitor
 * index. If the icon index is is greater than the number of tag icons then it will wrap around
 * until it an icon matches. Similarly if there are two tag icons then it would alternate between
 * them. This works seamlessly with alternative tags and alttagsdecoration patches.
 */
static char *tagicons[][NUMTAGS] = {
//	[DEFAULT_TAGS]        = { "1", "2", "3", "4", "5", "6", "7", "8", "9" },
	[DEFAULT_TAGS]        = { "₁", "₂", "₃", "₄", "₅", "₆", "₇", "₈", "₉" },
	[ALTERNATIVE_TAGS]    = { "A", "B", "C", "D", "E", "F", "G", "H", "I" },
	[ALT_TAGS_DECORATION] = { "<1>", "<2>", "<3>", "<4>", "<5>", "<6>", "<7>", "<8>", "<9>" },
};




/* There are two options when it comes to per-client rules:
 *  - a typical struct table or
 *  - using the RULE macro
 *
 * A traditional struct table looks like this:
 *    // class      instance  title  wintype  tags mask  isfloating  monitor
 *    { "Gimp",     NULL,     NULL,  NULL,    1 << 4,    0,          -1 },
 *    { "Firefox",  NULL,     NULL,  NULL,    1 << 7,    0,          -1 },
 *
 * The RULE macro has the default values set for each field allowing you to only
 * specify the values that are relevant for your rule, e.g.
 *
 *    RULE(.class = "Gimp", .tags = 1 << 4)
 *    RULE(.class = "Firefox", .tags = 1 << 7)
 *
 * Refer to the Rule struct definition for the list of available fields depending on
 * the patches you enable.
 */
static const Rule rules[] = {
	/* xprop(1):
	 *	WM_CLASS(STRING) = instance, class
	 *	WM_NAME(STRING) = title
	 *	WM_WINDOW_ROLE(STRING) = role
	 *	_NET_WM_WINDOW_TYPE(ATOM) = wintype
	 */
	RULE(.wintype = WTYPE "DIALOG", .isfloating = 1)
	RULE(.wintype = WTYPE "UTILITY", .isfloating = 1)
	RULE(.wintype = WTYPE "TOOLBAR", .isfloating = 1)
	RULE(.wintype = WTYPE "SPLASH", .isfloating = 1)
	RULE(.instance= "main", .class = "Psi+", .tags = 1 << 3)
	RULE(.instance= "tabs", .class = "Psi+", .tags = 1 << 3)
	RULE(.class = "Claws-mail", .tags = 1 << 3)
	RULE(.class = "Zoiper", .tags = 1 << 3)
	RULE(.class = "linphone", .tags = 1 << 3)
	RULE(.class = "Skype", .tags = 1 << 3)
	RULE(.class = "Mattermost", .tags = 1 << 3)

	RULE(.class = "pinentry-qt", .isfloating = 1)
	RULE(.class = "pinentry-qt5", .isfloating = 1)
	RULE(.class = "Nm-connection-editor", .isfloating = 1)
	RULE(.class = "blueman-manager", .isfloating = 1)
	RULE(.class = "pavucontrol-qt", .isfloating = 0)
	RULE(.class = "Firefox", .wintype = WTYPE "NORMAL", .tags = 1 << 2)

	RULE(.class = "Spotify", .tags = 1 << 8)
	RULE(.class = "Kasts", .tags = 1 << 8)

	RULE(.class = "st-tilda", .isfloating = 1)
	RULE(.class = "st-256color", .isterminal = 1)
};



/* Bar rules allow you to configure what is shown where on the bar, as well as
 * introducing your own bar modules.
 *
 *    monitor:
 *      -1  show on all monitors
 *       0  show on monitor 0
 *      'A' show on active monitor (i.e. focused / selected) (or just -1 for active?)
 *    bar - bar index, 0 is default, 1 is extrabar
 *    alignment - how the module is aligned compared to other modules
 *    widthfunc, drawfunc, clickfunc - providing bar module width, draw and click functions
 *    name - does nothing, intended for visual clue and for logging / debugging
 */
static const BarRule barrules[] = {
	/* monitor  bar    alignment         widthfunc                drawfunc                clickfunc                name */
	{  -1,       0,     BAR_ALIGN_LEFT,   width_pwrl_tags,         draw_pwrl_tags,         click_pwrl_tags,         "powerline_tags" },
	//{ -1,       0,     BAR_ALIGN_LEFT,   width_tags,              draw_tags,              click_tags,              "tags" },
	{ 'A',       0,     BAR_ALIGN_RIGHT,  width_systray,           draw_systray,           click_systray,           "systray" },
	{ -1,       0,     BAR_ALIGN_LEFT,   width_ltsymbol,          draw_ltsymbol,          click_ltsymbol,          "layout" },
//	{ 'A',       0,     BAR_ALIGN_RIGHT,  width_pwrl_status,       draw_pwrl_status,       click_pwrl_status,       "powerline_status" },
	{ statusmon, 0,     BAR_ALIGN_RIGHT,  width_status,            draw_status,            click_statuscmd,         "status" },
	{ -1,       0,     BAR_ALIGN_NONE,   width_bartabgroups,      draw_bartabgroups,      click_bartabgroups,      "bartabgroups" },
};

/* layout(s) */
static const float mfact     = 0.55; /* factor of master area size [0.05..0.95] */
static const int nmaster     = 1;    /* number of clients in master area */
static const int resizehints = 0;    /* 1 means respect size hints in tiled resizals */
static const int decorhints  = 1;    /* 1 means respect decoration hints */

#define FORCE_VSPLIT 1


static const Layout layouts[] = {
	/* symbol     arrange function */
	{ "[]=",      tile },    /* first entry is default */
	{ "><>",      NULL },    /* no layout function means floating behavior */
	{ "[M]",      monocle },
	{ "|M|",      centeredmaster },
	{ ">M>",      centeredfloatingmaster },
	{ "[\\]",     dwindle },
	{ "###",      nrowgrid },
};


/* key definitions */
#define MODKEY Mod4Mask
#define AltMask Mod1Mask
#define ALTKEY Mod1Mask
#define TAGKEYS(KEY,TAG) \
	{ MODKEY,                       KEY,      view,           {.ui = 1 << TAG} }, \
	{ MODKEY|ControlMask,           KEY,      toggleview,     {.ui = 1 << TAG} }, \
	{ MODKEY|ShiftMask,             KEY,      tag,            {.ui = 1 << TAG} }, \
	{ MODKEY|ControlMask|ShiftMask, KEY,      toggletag,      {.ui = 1 << TAG} },



/* helper for spawning shell commands in the pre dwm-5.0 fashion */
#define SHCMD(cmd) { .v = (const char*[]){ "/bin/sh", "-c", cmd, NULL } }

/* commands */
static char dmenumon[2] = "0"; /* component of dmenucmd, manipulated in spawn() */
static const char *dmenucmd[] = {
	"dmenu_run",
	"-m", dmenumon,
	"-fn", dmenufont,
	"-nb", normbgcolor,
	"-nf", normfgcolor,
	"-sb", selbgcolor,
	"-sf", selfgcolor,
	NULL
};
//static const char *termcmd[]  = { "st", NULL };
//static const char *tmuxcmd[]  = { "st", "-c", "st-tmux", "-e", "/home/wiebel/sync/bin/tmux-spawn.sh", NULL };
static const char *termcmd[]  = { "kitty", NULL };
static const char *tmuxcmd[]  = { "kitty", "-e", "/home/wiebel/sync/bin/tmux-spawn.sh", NULL };
// static const char scratchpadname[] = "tilda";
/* static const char *scratchpadcmd[] = { "st", "-t", scratchpadname, "-g", "120x34", NULL }; */
// static const char *scratchpadcmd[] = { "st", "-t", scratchpadname, "-c", "st-tilda", "-g", "180x18", "-e",  "tmux", "new-session", "-A",  "-s", "tilda", NULL };

static const char *volup[]   = { "/opt/pavolume/pavolume", "volup", "10",     NULL };
static const char *voldn[]   = { "/opt/pavolume/pavolume", "voldown", "10",     NULL };
static const char *volmute[] = { "/opt/pavolume/pavolume", "mutetoggle",     NULL };
static const char *playpause[] = { "/usr/bin/playerctl", "play-pause",     NULL };
#include <X11/XF86keysym.h>

/* This defines the name of the executable that handles the bar (used for signalling purposes) */
#define STATUSBAR "dwmblocks"


static Key keys[] = {
	/* modifier                     key            function                argument */
	{ MODKEY,                       XK_p,          spawn,                  {.v = dmenucmd } },
	{ MODKEY|ShiftMask,             XK_Return,     spawn,                  {.v = tmuxcmd } },
	{ MODKEY|ControlMask,           XK_Return,     spawn,                  {.v = termcmd } },
	{ MODKEY,                       XK_b,          togglebar,              {0} },
	{ MODKEY|ControlMask,		XK_s,	  spawn,	   SHCMD("transset -a --dec .1") },
	{ MODKEY|ControlMask,		XK_d,	  spawn,	   SHCMD("transset -a --inc .1") },
	{ ALTKEY,                       XK_w,	  spawn,	   SHCMD("pass-wrapper.sh") },
	{ MODKEY,                       XK_n,	  spawn,	   SHCMD("networkmanager_dmenu") },
//	{ MODKEY,                       XK_grave, spawn,	   SHCMD("/home/wiebel/sync/bin/st-tilda.sh") },
	{ ALTKEY|ControlMask,		XK_l,	  spawn,	   SHCMD("/usr/local/bin/lock.me") },
  { 0, XK_Print,     spawn,        SHCMD("/usr/bin/spectacle") },
  /* Media Keys */
  { 0, XF86XK_MonBrightnessUp,     spawn,        SHCMD("brightnessctl s +5%") },
  { 0, XF86XK_MonBrightnessDown,   spawn,        SHCMD("brightnwssctl s 5%-") },
  { 0, XF86XK_AudioRaiseVolume,    spawn,        {.v = volup } },
  { 0, XF86XK_AudioLowerVolume,    spawn,        {.v = voldn } },
  { 0, XF86XK_AudioMute,           spawn,        {.v = volmute } },
  { 0, XF86XK_AudioPlay,           spawn,        {.v = playpause } },
	{ MODKEY,                       XK_j,          focusstack,             {.i = +1 } },
	{ MODKEY,                       XK_k,          focusstack,             {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_j,          inplacerotate,          {.i = +1} },
	{ MODKEY|ShiftMask,             XK_k,          inplacerotate,          {.i = -1} },
	{ MODKEY,                       XK_i,          incnmaster,             {.i = +1 } },
	{ MODKEY,                       XK_d,          incnmaster,             {.i = -1 } },
	{ MODKEY,                       XK_h,          setmfact,               {.f = -0.05} },
	{ MODKEY,                       XK_l,          setmfact,               {.f = +0.05} },
	{ MODKEY,                       XK_x,          transfer,               {0} },
	{ MODKEY,                       XK_Return,     zoom,                   {0} },
//	{ MODKEY|AltMask,              XK_u,          incrgaps,               {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_u,          incrgaps,               {.i = -1 } },
//	{ MODKEY|AltMask,              XK_i,          incrigaps,              {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_i,          incrigaps,              {.i = -1 } },
//	{ MODKEY|AltMask,              XK_o,          incrogaps,              {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_o,          incrogaps,              {.i = -1 } },
//	{ MODKEY|AltMask,              XK_6,          incrihgaps,             {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_6,          incrihgaps,             {.i = -1 } },
//	{ MODKEY|AltMask,              XK_7,          incrivgaps,             {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_7,          incrivgaps,             {.i = -1 } },
//	{ MODKEY|AltMask,              XK_8,          incrohgaps,             {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_8,          incrohgaps,             {.i = -1 } },
//	{ MODKEY|AltMask,              XK_9,          incrovgaps,             {.i = +1 } },
//	{ MODKEY|AltMask|ShiftMask,    XK_9,          incrovgaps,             {.i = -1 } },
//	{ MODKEY|AltMask,              XK_0,          togglegaps,             {0} },
//	{ MODKEY|AltMask|ShiftMask,    XK_0,          defaultgaps,            {0} },
	{ MODKEY,                       XK_Tab,        view,                   {0} },
	{ MODKEY|ControlMask,           XK_z,          showhideclient,         {0} },
	{ MODKEY,                       XK_q,          killclient,             {0} },
	{ MODKEY|ShiftMask,             XK_c,          killclient,             {0} },
	{ MODKEY|ShiftMask,             XK_q,          quit,                   {0} },
	{ MODKEY,                       XK_t,          setlayout,              {.v = &layouts[0]} },
	{ MODKEY,                       XK_f,          setlayout,              {.v = &layouts[1]} },
	{ MODKEY,                       XK_m,          setlayout,              {.v = &layouts[2]} },
	{ MODKEY,                       XK_u,          setlayout,              {.v = &layouts[3]} },
	{ MODKEY,                       XK_o,          setlayout,              {.v = &layouts[4]} },
	{ MODKEY|ShiftMask,             XK_t,          setlayout,              {.v = &layouts[5]} },
	{ MODKEY,                       XK_g,          setlayout,              {.v = &layouts[6]} },
	{ MODKEY,                       XK_space,      setlayout,              {0} },
	{ MODKEY|ShiftMask,             XK_space,      togglefloating,         {0} },
	{ MODKEY|ShiftMask,             XK_y,          togglefakefullscreen,   {0} },
	{ MODKEY|ShiftMask,             XK_s,          togglesticky,           {0} },
	{ MODKEY,                       XK_grave,      scratchpad_show,        {0} },
	{ MODKEY,                       XK_Escape,        scratchpad_show,        {0} },
	{ MODKEY|ShiftMask,             XK_grave,      scratchpad_hide,        {0} },
	{ MODKEY|ShiftMask,             XK_Escape,        scratchpad_hide,        {0} },
	{ MODKEY|ShiftMask|ControlMask, XK_grave,      scratchpad_remove,      {0} },
	{ MODKEY|ShiftMask|ControlMask, XK_Escape,        scratchpad_remove,      {0} },
	{ MODKEY,                       XK_comma,      focusmon,               {.i = -1 } },
	{ MODKEY,                       XK_period,     focusmon,               {.i = +1 } },
	{ MODKEY|ShiftMask,             XK_comma,      tagmon,                 {.i = -1 } },
	{ MODKEY|ShiftMask,             XK_period,     tagmon,                 {.i = +1 } },
	{ MODKEY,                       XK_Left,       viewtoleft,             {0} },
	{ MODKEY,                       XK_Right,      viewtoright,            {0} },
	{ MODKEY|ShiftMask,             XK_Left,       tagtoleft,              {0} },
	{ MODKEY|ShiftMask,             XK_Right,      tagtoright,             {0} },
	{ MODKEY|ControlMask,           XK_Left,       tagandviewtoleft,       {0} },
	{ MODKEY|ControlMask,           XK_Right,      tagandviewtoright,      {0} },
	{ MODKEY|ControlMask,           XK_comma,      tagallmon,              {.i = +1 } },
	{ MODKEY|ControlMask,           XK_period,     tagallmon,              {.i = -1 } },
	{ MODKEY|ShiftMask|ControlMask, XK_comma,      tagswapmon,             {.i = +1 } },
	{ MODKEY|ShiftMask|ControlMask, XK_period,     tagswapmon,             {.i = -1 } },

  { MODKEY,                       XK_0,          view,                   {.ui = ~0 } },
	{ MODKEY|ShiftMask,             XK_0,          tag,                    {.ui = ~0 } },
	TAGKEYS(                        XK_1,                                  0)
	TAGKEYS(                        XK_2,                                  1)
	TAGKEYS(                        XK_3,                                  2)
	TAGKEYS(                        XK_4,                                  3)
	TAGKEYS(                        XK_5,                                  4)
	TAGKEYS(                        XK_6,                                  5)
	TAGKEYS(                        XK_7,                                  6)
	TAGKEYS(                        XK_8,                                  7)
	TAGKEYS(                        XK_9,                                  8)
};


/* button definitions */
/* click can be ClkTagBar, ClkLtSymbol, ClkStatusText, ClkWinTitle, ClkClientWin, or ClkRootWin */
static Button buttons[] = {
	/* click                event mask           button          function        argument */
	{ ClkLtSymbol,          0,                   Button1,        setlayout,      {0} },
	{ ClkLtSymbol,          0,                   Button3,        setlayout,      {.v = &layouts[2]} },
	{ ClkWinTitle,          0,                   Button1,        togglewin,      {0} },
	{ ClkWinTitle,          0,                   Button3,        showhideclient, {0} },
	{ ClkWinTitle,          0,                   Button2,        zoom,           {0} },
	{ ClkStatusText,        0,                   Button1,        sigstatusbar,   {.i = 1 } },
	{ ClkStatusText,        0,                   Button2,        sigstatusbar,   {.i = 2 } },
	{ ClkStatusText,        0,                   Button3,        sigstatusbar,   {.i = 3 } },
	{ ClkClientWin,         MODKEY,              Button1,        movemouse,      {0} },
	{ ClkClientWin,         MODKEY,              Button2,        togglefloating, {0} },
	{ ClkClientWin,         MODKEY,              Button3,        resizemouse,    {0} },
	{ ClkTagBar,            0,                   Button1,        view,           {0} },
	{ ClkTagBar,            0,                   Button3,        toggleview,     {0} },
	{ ClkTagBar,            MODKEY,              Button1,        tag,            {0} },
	{ ClkTagBar,            MODKEY,              Button3,        toggletag,      {0} },
};


